local function SuperAdvanceJump(player)
	local mo = player.mo
	if player.powers[pw_carry]
		return
	end
	if player.speed >= FixedMul(mo.scale,player.runspeed)
		mo.state = S_PLAY_RUN
	else
		mo.state = P_MobjFlip(mo)*mo.momz > 0 and S_PLAY_SPRING or S_PLAY_FALL
	end
end

local function GotEmeraldForm(player)
	if emeralds == 127 //All emeralds!
	and player.rings >= 50 //Check 50 Rings
	and not P_IsObjectOnGround(player.mo)
	and player.pflags & PF_JUMPED
	and not player.powers[pw_super]
		return true
	else
		return false
	end
end

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if player.mo and player.mo.skin == "advancesonic" and player.mo.valid
		and player.playerstate == PST_LIVE
		and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if GotEmeraldForm(player)
			and not (player.pflags & PF_SPINDOWN)
			and (player.cmd.buttons & BT_SPIN)
			and not player.powers[pw_shield]
			and not player.powers[pw_invulnerability]
				S_StartSound(player.mo, sfx_s3k9c)
			end
		end
	end
end)

local function advancehudspeed(v, player)
	if (player.mo and player.mo.valid and player.mo.skin == "advancesonic")
	and not player.powers[pw_carry]
	and player.playerstate == PST_LIVE
		if (player.speed > 70*FRACUNIT)
			if (leveltime % 2 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%8)/2)), V_80TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 3 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%4)/6)), V_70TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 4 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%5)/6)), V_50TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 5 == 0)
				v.drawScaled(0,0,  65355,v.cachePatch("ADVESP"+tostring((leveltime%8)/5)), V_40TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 6 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%5)/5)), V_30TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			elseif (leveltime % 7 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%4)/2)), V_30TRANS|V_SNAPTORIGHT|V_SNAPTOTOP)
			elseif (leveltime % 8 == 0)
				v.drawScaled(0,0, 65355,v.cachePatch("ADVESP"+tostring((leveltime%8)/4)), V_20TRANS|V_SNAPTOLEFT|V_SNAPTOTOP)
			end
		end
	end
end

hud.add(advancehudspeed)

addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "advancesonic")
			if (player.pflags & PF_JUMPED)
			and not ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
				if (player.powers[pw_super])
				and not P_IsObjectOnGround(player.mo)
					SuperAdvanceJump(player)
					player.pflags = $1 & ~PF_SPINDOWN
					player.pflags = $1 & ~PF_STARTDASH
					player.pflags = $1 & ~PF_SPINNING
					if (player.cmd.buttons & BT_JUMP)
						if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
						or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
							P_SetObjectMomZ(player.mo, 1*FRACUNIT, true)
						else
							P_SetObjectMomZ(player.mo, FRACUNIT*3/2, 1)
						end
					elseif (player.cmd.buttons & BT_USE)
						P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
					else
						if player.mo.momz >= 1
							player.mo.momz = player.mo.momz - 1*FRACUNIT
						elseif player.mo.momz <= -1
							player.mo.momz = player.mo.momz + 1*FRACUNIT
						elseif player.mo.momz > -2 and player.mo.momz < 2
							player.mo.momz = 0
						end
					end
				end
			end
			if ((player.mo.state == S_PLAY_SUPER_TRANS1) or (player.mo.state == S_PLAY_SUPER_TRANS2))
				player.pflags = $1 & ~PF_JUMPED
			end
		end
	end
end)