freeslot("MT_ADVANCESPINWAVE","S_ADVANCESPIN_WAVE1","S_ADVANCESPIN_WAVE2","S_ADVANCESPIN_WAVE3",
"S_ADVANCESPIN_WALL1","S_ADVANCESPIN_WALL2","S_ADVANCESPIN_WALL3", "S_ADVANCESPIN_WAVE_ACTIVE", "S_ADVANCESPIN_WAVE_END",
 "SPR_SPNV", "SPR_SPNW", "SPR_SPNX", "SPR_SPDV", "SPR_SPDW", "SPR_SPDX")

states[S_ADVANCESPIN_WAVE1] = {
	sprite = SPR_SPNV,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 4,
	var1 = 2,
	var2 = 2,
	nextstate = S_ADVANCESPIN_WAVE2
}

states[S_ADVANCESPIN_WAVE2] = { 
	sprite = SPR_SPNW,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	var1 = 6,
	var2 = 1,
	nextstate = S_ADVANCESPIN_WAVE2
}


states[S_ADVANCESPIN_WAVE3] = { 
	sprite = SPR_SPNX,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	var1 = 6,
	var2 = 1,
	nextstate = S_NULL
}

states[S_ADVANCESPIN_WALL1] = { // side  effects
	sprite = SPR_SPDV,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 4,
	var1 = 2,
	var2 = 2,
	nextstate = S_ADVANCESPIN_WALL2
}

states[S_ADVANCESPIN_WALL2] = { // test
	sprite = SPR_SPDW,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	var1 = 6,
	var2 = 1,
	nextstate = S_ADVANCESPIN_WALL2
}


states[S_ADVANCESPIN_WALL3] = { // test
	sprite = SPR_SPDX,
	frame = FF_ANIMATE|FF_PAPERSPRITE|FF_FULLBRIGHT|A,
	tics = 6,
	var1 = 6,
	var2 = 1,
	nextstate = S_NULL
}

states[S_ADVANCESPIN_WAVE_ACTIVE] = { // projectile states
	sprite = SPR_NULL,
	frame = MF2_DONTDRAW|A,
	tics = 700,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

states[S_ADVANCESPIN_WAVE_END] = {  
	sprite = SPR_NULL,
	frame = MF2_DONTDRAW|A,
	tics = 7,
	var1 = 0,
	var2 = 0,
	nextstate = S_NULL
}

mobjinfo[MT_ADVANCESPINWAVE] = {
	name = "Advance Spin Wave",
	doomednum = -1,
	spawnhealth = 100,
	spawnstate = S_ADVANCESPIN_WAVE_ACTIVE,
	deathstate = S_ADVANCESPIN_WAVE_END,
	radius = 32*FRACUNIT,
	height = 96*FRACUNIT,
	damage = 1,
	flags = MF_NOBLOCKMAP|MF_SCENERY // add |MF_MISSILE latter?
}

//-------- spawn paper sprite effects for spin wave------------//
addHook("MobjSpawn", function(mo)
	
	if mo.rightwaves == nil then
	S_StartSound(mo, sfx_s3k57)
	mo.centerwaves = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	mo.centerwaves.state = S_ADVANCESPIN_WAVE1
	mo.centerwaves.angle = mo.angle
	mo.centerwaves.target = mo
	mo.centerwaves.blendmode = AST_ADD
	mo.centerwaves.color = SKINCOLOR_SKY
	mo.rightwaves = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	mo.rightwaves.state = S_ADVANCESPIN_WALL1
	mo.rightwaves.angle = mo.angle
	mo.rightwaves.target = mo
	mo.rightwaves.color = SKINCOLOR_SKY
	mo.rightwaves.blendmode = AST_ADD
	mo.leftwaves = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	mo.leftwaves.state = S_ADVANCESPIN_WALL1
	mo.leftwaves.angle = mo.angle
	mo.leftwaves.target = mo
	mo.leftwaves.color = SKINCOLOR_SKY
	mo.leftwaves.blendmode = AST_ADD
	end
end, MT_ADVANCESPINWAVE)

//-------- spin wave thinker ------------//
addHook("MobjThinker", function(mo)

		// prevent spawning into higher sectors!
	if mo.target and mo.target.valid and mo.spawntime <= 2  then
		if (P_MobjFlip(mo) > 0 and mo.z > mo.target.z+25*FRACUNIT) or (P_MobjFlip(mo) < 0 and mo.z < mo.target.z-25*FRACUNIT) then
			P_RemoveMobj(mo)
			return
		end
	mo.spawntime = $+1
	elseif mo.target and mo.target.valid and mo.spawntime > 2 and mo.spawntime < 5  then
		mo.spawntime = 5
		P_Thrust(mo,mo.angle,mo.startingspeed)
		mo.flags = $|MF_MISSILE
	else
		mo.spawntime = $+1
	end
 if mo and mo.valid and mo.state == S_ADVANCESPIN_WAVE_ACTIVE  then
	mo.friction = 1*FRACUNIT
	local moveingspeed = FixedHypot(mo.momx, mo.momy)
	local forwardoffset = 20
	if mo.centerwaves and mo.centerwaves.valid and mo and mo.valid then
		local frontoffset = mo.radius/FRACUNIT
		A_CapeChase(mo.centerwaves, (0 * 65536)+0, (frontoffset * 65536)+0)
		mo.centerwaves.angle = (mo.angle-ANGLE_90)
		mo.centerwaves.color = mo.color
		mo.centerwaves.blendmode = AST_ADD
	end
	if mo.rightwaves and mo.rightwaves.valid and mo and mo.valid then
		local rightoffset = 20
		A_CapeChase(mo.rightwaves, (0 * 65536)+0, (forwardoffset * 65536)+rightoffset)
		mo.rightwaves.angle = mo.angle+ANG30
		mo.rightwaves.color = mo.color
		mo.rightwaves.blendmode = AST_ADD
	end
	if mo.leftwaves and mo.leftwaves.valid and mo and mo.valid then
		local leftoffset = -20
		A_CapeChase(mo.leftwaves, (0 * 65536)+0, (forwardoffset * 65536)+leftoffset)
		mo.leftwaves.angle = mo.angle-ANG30
		mo.leftwaves.color = mo.color
		mo.leftwaves.blendmode = AST_ADD
	end
	if moveingspeed < mo.startingspeed/2 and mo.spawntime >= 10 then
		P_KillMobj(mo, mo)
	end
	if moveingspeed < mo.startingspeed/2 and mo.spawntime >= 10 then
		P_KillMobj(mo, mo)
	end
	if mo.spawntime > 1*TICRATE and mo.spawntime < 50*TICRATE then
		P_KillMobj(mo, mo)
		mo.spawntime = 99*TICRATE
	end
 end
end, MT_ADVANCESPINWAVE)

addHook("MobjMoveBlocked", function(mo,thing,line)
	if mo and mo.valid then
		P_KillMobj(mo, mo)
	end
end, MT_ADVANCESPINWAVE)

// make paper sprites play death animation //
addHook("MobjDeath", function(mo, inflictor, source, damagetype)
 if mo and mo.valid then
	if mo.centerwaves and mo.centerwaves.valid then
			mo.centerwaves.state = S_ADVANCESPIN_WAVE3
	end
	if mo.rightwaves and mo.rightwaves.valid then
			mo.rightwaves.state = S_ADVANCESPIN_WALL3
	end
	if mo.leftwaves and mo.leftwaves.valid then
			mo.leftwaves.state = S_ADVANCESPIN_WALL3
	end
 end
end, MT_ADVANCESPINWAVE)

addHook("MobjRemoved", function(mo) // remove effects too
	if mo and mo.valid then
		if mo.centerwaves and mo.centerwaves.valid then
			P_RemoveMobj(mo.centerwaves)
			P_RemoveMobj(mo.rightwaves)
			P_RemoveMobj(mo.leftwaves)
			mo.centerwaves = false
			mo.rightwaves = false
			mo.leftwaves = false
		end
	end
end, MT_ADVANCESPINWAVE)

addHook("MobjDamage", function(mo, inflictor, source, damage, damagetype) //spin wave make hit sound

	if inflictor and inflictor.valid and inflictor.type == MT_ADVANCESPINWAVE then
	if mo.player and mo.player.valid and mo.player.guard >= 1 then else
		S_StartSound(mo, sfx_kc40)
		end
	end

end, MT_NULL)

local function SpinWaveObjCollide(mo, mobj)
	if mobj and mobj.valid and (mobj.flags & MF_SOLID) then
		if not (mo.z+(1*FRACUNIT) >= mobj.z+mobj.height)
		and not(mobj.z+(1*FRACUNIT) >= mo.z+mo.height) then
		if (mobj.type == MT_PLAYER and mobj.player.powers[pw_flashing]) then return false end
		if (mobj.flags & MF_MONITOR) or (mobj.type == MT_PLAYER) then return end
		P_KillMobj(mo, mo)
		end
	end
end

addHook("MobjMoveCollide", SpinWaveObjCollide, MT_ADVANCESPINWAVE)
addHook("MobjCollide", SpinWaveObjCollide, MT_ADVANCESPINWAVE)